﻿/*----------------------------------------------------------------
variable declarations
----------------------------------------------------------------*/
var M_PI = 3.14159265358979;
var	TWO_PI:Number;

var samplingPeriod, samplingFreq, testFreq, time:Number;
var power:Number;

var samples, power:Number;   // int	samples, power;
var real:Array;				//double	*real, *imag, max;
var imag:Array;
var maxAmplitude:Number;
var band:Boolean;

var magArray:Array;

var xData:Array;
var pointArray:Array;
var xOffset:Number = 110.5;    //250;
var yOffsetMin:Number = 21.0;    
var yOffsetMax:Number = 250.6;    
var yLinearOffset:Number = 200;
var yLogOffset:Number = 100;   

var maxPixelsHorizontalAxis:Number = 279;
var maxBandwidth:Number = 40000000.0;
var zoomFactor:Number = 1;
var logAmplitude:Boolean = true;
var zoomTween:Object;

/*----------------------------------------------------------------
instantiate variables
----------------------------------------------------------------*/
testFreq = 2000.0;
samplingFreq = 80000000.0;   //3000.0;
samplingPeriod = 1.0 / samplingFreq;

TWO_PI = Math.PI * 2.0;

real = new Array();
imag = new Array();
xData = new Array();
magArray = new Array(maxDataSegments);

xData = [
     [-28,36],   [-44,52],   [-51,44],   [-43,17],   [-18,-16],  [15,-41],
     [39,-47],   [43,-36],   [24,-17],   [-12,-2],   [-48,0],    [-69,-7],
     [-64,-18],  [-37,-22],  [-1,-15],   [29,2],     [41,20],    [32,28],
     [11,19],    [-12,-3],   [-28,-29],  [-30,-47],  [-22,-48],  [-13,-30],
     [-8,-2],    [-11,25],   [-17,38],   [-21,33],   [-17,16],   [-7,-6],
     [3,-25],    [10,-35],   [6,-36],    [-7,-33],   [-23,-26],  [-35,-19],
     [-39,-11],  [-33,-2],   [-19,6],    [-6,10],    [5,7],      [13,-5],
     [19,-23],   [21,-40],   [20,-50],   [14,-47],   [0,-32],    [-19,-12],
     [-36,4],    [-42,12],   [-33,11],   [-9,5],     [22,-1],    [49,-1],
     [57,0],     [44,1],     [15,-4],    [-19,-17],  [-44,-33],  [-52,-42],
     [-41,-36],  [-19,-15],  [1,14],     [11,38],    [11,46],    [5,35],
     [-2,4],     [-2,-30],   [3,-54],    [9,-61],    [8,-49],    [0,-26],
     [-11,-3],   [-22,10],   [-25,11],   [-16,5],    [-1,-5],    [15,-12],
     [25,-14],   [25,-13],   [19,-11],   [11,-9],    [5,-8],     [6,-6],
     [9,-1],     [10,3],     [6,4],      [-2,0],     [-9,-9],    [-12,-15],
     [-7,-16],   [-1,-5],    [5,13],     [6,31],     [1,42],     [-5,34],
     [-7,11],    [-2,-18],   [10,-43],   [21,-50],   [22,-39],   [8,-14],
     [-16,12],   [-42,27],   [-55,26],   [-46,12],   [-16,-3],   [23,-12],
     [53,-11],   [63,-2],    [49,7],     [18,8],     [-18,-2],   [-41,-18],
     [-43,-30],  [-26,-29],  [-1,-13],   [21,14],    [28,39],    [19,50],
     [3,43],     [-12,22],   [-16,-5],   [-10,-23],  [3,-27],    [14,-14],
     [15,7],     [5,26],
	 
     [ -12,33  ],[ -26,24  ],[ -33,7  ], [ -30,-11  ],[ -19,-20  ],[ -7,-14  ],
     [ 0,3  ],   [ -2,23  ], [ -10,37  ],[ -17,37  ], [ -21,22  ], [ -17,-1  ],
     [ -6,-23  ],[ 5,-34  ],[ 8,-34  ],[ 0,-21  ],[ -19,-3  ],[ -41,14  ],
	 [ -59,21  ],[ -58,18  ],[ -40,10  ],[ -11,2  ],[ 20,-1  ],[ 38,-1  ],
	 [ 38,0  ],[ 17,-5  ],[ -15,-16  ],[ -45,-31  ],[ -62,-44  ],[ -60,-45  ],
     [ -42,-31  ],[ -17,-2  ],[ 1,28  ],[ 9,47  ],[ 7,45  ],[ 0,22  ],
     [ -4,-17  ],[ -2,-56  ],[ 4,-78  ],[ 7,-74  ],[ 1,-50  ],[ -14,-14  ],
     [ -35,17  ],[ -50,32  ],[ -50,28  ],[ -30,10  ],[ 3,-12  ],[ 36,-26  ],
     [ 56,-30  ],[ 54,-26  ],[ 31,-20  ],[ -2,-18  ],[ -33,-22  ],[ -48,-28  ],
     [ -43,-28  ],[ -23,-20  ],[ 3,-4  ],[ 23,13  ],[ 31,23  ],[ 29,22  ],
     [ 19,8  ],[ 11,-11  ],[ 5,-27  ],[ 3,-33  ],[ 3,-29  ],[ 3,-16  ],
     [ 1,-3  ],[ -1,7  ],[ -1,10  ],[ 1,8  ],[ 4,5  ],[ 6,3  ],
     [ 5,5  ],[ 0,6  ],[ -5,5  ],[ -5,4  ],[ 2,3  ],[ 13,1  ],
     [ 21,2  ],[ 23,6  ],[ 15,6  ],[ -3,3  ],[ -21,-4  ],[ -33,-12  ],
     [ -33,-16  ],[ -21,-9  ],[ -4,9  ],[ 12,32  ],[ 18,48  ],[ 13,50  ],
     [ 2,35  ],[ -6,4  ],[ -7,-29  ],[ -3,-49  ],[ 2,-47  ],[ 1,-24  ],
     [ -10,10  ],[ -29,40  ],[ -46,53  ],[ -53,45  ],[ -42,23  ],[ -16,-2  ],
     [ 15,-19  ],[ 35,-21  ],[ 35,-9  ],[ 15,5  ],[ -20,12  ],[ -51,7  ],
     [ -67,-8  ],[ -60,-25  ],[ -33,-32  ],[ -3,-24  ],[ 18,-5  ],[ 21,15  ],
     [ 3,27  ],[ -22,22  ],[ -40,4  ],[ -41,-19  ],[ -25,-36  ],[ 0,-37  ],
     [ 22,-24  ],[ 29,-4  ],[ 20,11  ],[ -2,13  ],[ -26,1  ],[ -41,-17  ],
     [ -41,-30  ],[ -29,-30  ],
	 
	[ -12,-15  ],[ 3,10  ],[ 7,32  ],[ 5,40  ],[ 1,31  ],[ -3,8  ],
	[ -4,-20  ],[ -3,-42  ],[ -5,-50  ],[ -13,-42  ],[ -26,-24  ],[ -39,-4  ],
	[ -47,12  ],[ -43,20  ],[ -29,20  ],[ -9,14  ],[ 10,3  ],[ 22,-11  ],
	[ 23,-25  ],[ 14,-39  ],[ -1,-49  ],[ -14,-49  ],[ -25,-40  ],[ -31,-23  ],
	[ -32,-3  ],[ -27,14  ],[ -16,20  ],[ -3,15  ],[ 14,2  ],[ 29,-14  ],
	[ 39,-24  ],[ 37,-28  ],[ 22,-24  ],[ -3,-17  ],[ -31,-12  ],[ -47,-11  ],
	[ -47,-11  ],[ -30,-9  ],[ -5,0  ],[ 18,12  ],[ 29,24  ],[ 25,26  ],
	[ 8,16  ],[ -13,-8  ],[ -26,-36  ],[ -27,-57  ],[ -18,-60  ],[ -6,-42  ],
	[ 0,-11  ],[ -5,21  ],[ -17,38  ],[ -26,33  ],[ -24,8  ],[ -9,-24  ],
	[ 16,-50  ],[ 38,-57  ],[ 48,-45  ],[ 37,-22  ],[ 9,1  ],[ -26,11  ],
	[ -49,6  ],[ -49,-7  ],[ -25,-19  ],[ 12,-20  ],[ 44,-7  ],[ 59,12  ],
	[ 51,26  ],[ 24,26  ],[ -9,8  ],[ -31,-17  ],[ -35,-40  ],[ -24,-45  ],
	[ -7,-30  ],[ 7,0  ],[ 10,32  ],[ 3,50  ],[ -9,47  ],[ -15,24  ],
	[ -11,-8  ],[ 1,-35  ],[ 14,-48  ],[ 18,-44  ],[ 10,-28  ],[ -8,-10  ],
	[ -27,4  ],[ -37,9  ],[ -32,9  ],[ -16,6  ],[ 6,3  ],[ 27,0  ],
	[ 36,-4  ],[ 34,-11  ],[ 25,-20  ],[ 13,-27  ],[ 0,-29  ],[ -11,-21  ],
	[ -19,-4  ],[ -24,15  ],[ -24,28  ],[ -17,32  ],[ -1,27  ],[ 21,16  ],
	[ 39,7  ],[ 45,2  ],[ 35,0  ],[ 9,0  ],[ -25,-5  ],[ -53,-13  ],
	[ -63,-20  ],[ -53,-17  ],[ -30,-3  ],[ -3,20  ],[ 14,42  ],[ 16,50  ],
	[ 7,40  ],[ -7,8  ],[ -17,-31  ],[ -17,-62  ],[ -11,-73  ],[ -7,-60  ],
	[ -9,-30  ],[ -18,4  ],[ -29,28  ],[ -34,32  ],[ -27,18  ],[ -8,-2  ],
	[ 17,-21  ],[ 36,-29  ],

	[ 41,-29  ],[ 31,-22  ],[ 13,-17  ],[ -5,-13  ],[ -15,-10  ],[ -14,-7  ],
	[ -8,-1  ],[ 0,5  ],[ 5,10  ],[ 5,9  ],[ 4,3  ],[ 4,-2  ],
	[ 7,-3  ],[ 11,5  ],[ 10,17  ],[ 3,27  ],[ -7,26  ],[ -13,13  ],
	[ -15,-8  ],[ -8,-29  ],[ 3,-38  ],[ 9,-30  ],[ 4,-8  ],[ -14,18  ],
	[ -35,35  ],[ -49,35  ],[ -45,20  ],[ -21,-1  ],[ 12,-17  ],[ 42,-22  ],
	[ 55,-17  ],[ 43,-9  ],[ 14,-6  ],[ -23,-9  ],[ -49,-18  ],[ -54,-24  ],
	[ -40,-20  ],[ -15,-4  ],[ 11,18  ],[ 26,34  ],[ 27,39  ],[ 21,30  ],
	[ 12,10  ],[ 5,-10  ],[ -1,-22  ],[ -5,-22  ],[ -11,-13  ],[ -17,1  ],
	[ -21,10  ],[ -19,12  ],[ -13,12  ],[ -6,12  ],[ -3,14  ],[ -9,17  ],
	[ -19,18  ],[ -32,13  ],[ -35,3  ],[ -27,-7  ],[ -8,-12  ],[ 11,-9  ],
	[ 21,-2  ],[ 14,5  ],[ -9,5  ],[ -37,-8  ],[ -57,-25  ],[ -61,-40  ],
	[ -47,-41  ],[ -22,-25  ],[ 0,4  ],[ 13,31  ],[ 11,42  ],[ 2,32  ],
	[ -6,2  ],[ -7,-36  ],[ -2,-65  ],[ 5,-73  ],[ 5,-58  ],[ -2,-30  ],
	[ -16,0  ],[ -30,20  ],[ -34,24  ],[ -23,15  ],[ -4,2  ],[ 17,-10  ],
	[ 29,-17  ],[ 31,-18  ],[ 23,-17  ],[ 9,-16  ],[ -1,-15  ],[ -5,-12  ],
	[ -4,-6  ],[ -1,1  ],[ 0,6  ],[ -3,5  ],[ -7,-1  ],[ -8,-8  ],
	[ -3,-11  ],[ 4,-5  ],[ 10,10  ],[ 9,29  ],[ 2,40  ],[ -7,37  ],
	[ -12,17  ],[ -8,-11  ],[ 1,-34  ],[ 11,-42  ],[ 12,-30  ],[ 0,-5  ],
	[ -25,22  ],[ -51,39  ],[ -65,39  ],[ -59,24  ],[ -33,4  ],[ 5,-10  ],
	[ 36,-13  ],[ 47,-6  ],[ 33,1  ],[ -1,1  ],[ -38,-10  ],[ -64,-27  ],
	[ -67,-40  ],[ -49,-40  ],[ -20,-26  ],[ 5,-1  ],[ 17,23  ],[ 11,33  ],
	[ -3,25  ],	[ -17,2  ]
	 
	 ];

/*----------------------------------------------------------------
functions
----------------------------------------------------------------*/

InitializeApplication = function():Void
{
   if ( SpectrumFlashDebug == NO_FLASH_DEBUG )
   {
      samples = 2048;
      zoomFactor = 1;
   }
   else
   {
      samples = 512;
	  zoomFactor = 1;
   }
	band = true;
	SetAveraging(maxDataSegments, "High");   
	SetResolution(samples, "High");
	SetBand(band, "Wide");
//   power =  Math.log(samples) / Math.log(2.0);
//   InitializeMagArray();
   InitializeFlash();
}

InitializeTimeDomain = function():Void
{
   for ( var loop=0; loop < xData.length; loop++)
   {  // Create real and imag data points
      imag[loop] = xData[loop][0];
      real[loop] = xData[loop][1];
   }
}

InitializeMagArray = function():Void
{
   var i:Number;
   var j:Number;
   for (i = 0; i < maxDataSegments; i++) 
   {
      magArray[i] = new Array(samples);
      for (j = 0; j < samples; j++) 
	  {
         magArray[i][j] = 0;
      }
   }
}

SmoothByHammingWindow = function():Void
{
   for ( var loop=0; loop < samples; loop++)
   {  // Smooth the real and imag data points
      imag[loop] = imag[loop] * (0.54 - 0.46 * Math.cos( TWO_PI * loop / samples ));
      real[loop] = real[loop] * (0.54 - 0.46 * Math.cos( TWO_PI * loop / samples ));
   }
}

SmoothByBlackmanWindow = function():Void
{
   for ( var loop=0; loop < samples; loop++)
   {  // Smooth the real and imag data points
      imag[loop] = imag[loop] * (0.42 - 0.5 * Math.cos( TWO_PI * loop / samples ) + 0.08 * Math.cos( 2 * TWO_PI * loop / samples ));
      real[loop] = real[loop] * (0.42 - 0.5 * Math.cos( TWO_PI * loop / samples ) + 0.08 * Math.cos( 2 * TWO_PI * loop / samples ));
   }
}

// Bit reverse the number
// Change 11100000b to 00000111b or vice-versa
Permute = function(index:Number):Number
{
	var n1, result;

	n1 = samples;
	result = 0;

	for (var loop = 0; loop < power; loop++)  
	{
		n1 >>= 1;			/* n1 / 2.0 */
		if (index < n1)
			continue;

		result +=  Math.pow(2.0, loop);
		index -= n1;
	}

	return( result );
}

//	Calculate Power Magnitude
FindMagnitude = function(n:Number):Number
{
	n = Permute(n);
	return (Math.sqrt(real[n] * real[n] + imag[n] * imag[n]));
}

//	Find maximum amplitude
FindMaximumAmplitude = function():Void
{
	var mag:Number;

	maxAmplitude = 0.0;
	for (var loop = 0; loop < samples; loop++)  
	{
		if ((mag = FindMagnitude(loop)) > maxAmplitude)
			maxAmplitude = mag;
	}
}

FastFourierTransform = function():Void
{
   var i1, i2, i3, i4, y:Number;              
   var loop1, loop2:Number;                 
   
   var loop:Number;                         
   var a1, a2, b1, b2, z1, z2, v:Number; 	

   // Scale the data 

	for (loop = 0; loop < samples; loop++)  
	{
		real[loop] /= samples;
		imag[loop] /= samples;
	}

	i1 = samples >> 1;
	i2 = 1;
	v = TWO_PI * (1.0 / samples);

	for (loop = 0; loop < power; loop++)  
	{
		i3 = 0;
		i4 = i1;

		for (loop1 = 0; loop1 < i2; loop1++)  
		{
			y = Permute(i3 / i1);
			z1 =  Math.cos(v * y);
			z2 = -Math.sin(v * y);

			for (loop2 = i3; loop2 < i4; loop2++)  
			{
				a1 = real[loop2];
				a2 = imag[loop2];

				b1 = z1*real[loop2+i1] - z2*imag[loop2+i1];
				b2 = z2*real[loop2+i1] + z1*imag[loop2+i1];

				real[loop2]      = a1 + b1;
				imag[loop2]      = a2 + b2;

				real[loop2 + i1] = a1 - b1;
				imag[loop2 + i1] = a2 - b2;
			}

			i3 += (i1 << 1);
			i4 += (i1 << 1);
		}

		i1 >>= 1;
		i2 <<= 1;
	}
}

DrawLine = function(fromX, fromY, toX, toY):Void 
{
   line_mc["i" + zoomFactor].lineStyle(1, changePointColor);
   line_mc["i" + zoomFactor].moveTo(fromX, fromY);
   line_mc["i" + zoomFactor].lineTo(toX, toY);
}

UpdateMagnitude = function():Void
{
	var	aMagnitude, loop:Number;
	var segmentIndex:Number = dataSegment;

	if (--segmentIndex < 0)
	   segmentIndex = 0;
	for (loop = 0; loop < samples; loop++)  
	{
        if (logAmplitude)
    		aMagnitude = 20 * Math.log( FindMagnitude(loop));
		else	
		    aMagnitude = FindMagnitude(loop) * 112.0 / maxAmplitude;
			
		magArray[segmentIndex][loop] = aMagnitude;	
	}
}

AverageMagnitude = function(aSample:Number):Number
{
	var aSum:Number = 0;
	var averageMagnitude:Number = 0;
	
    if (aSample < samples)
	{
	   if ( dataSegmentsLoaded )	
	   {
          for (var loop = 0; loop < dataSegmentsLoaded; loop++)  
          {
		     aSum = aSum + magArray[loop][aSample];	
          }
          averageMagnitude = aSum/dataSegmentsLoaded;
	   }
       else
          logger.debug("No Segments Loaded:", dataSegmentsLoaded);
	}
	else
       logger.debug("INVALID sample index:", aSample);
	return(averageMagnitude);
}

RangeCheckAmplitude = function(aValue:Number):Number
{
   var amplitude:Number = aValue;	
   if ( aValue < yOffsetMin )
	  amplitude = yOffsetMin; 
   else if ( aValue > yOffsetMax )
	  amplitude = yOffsetMax;
   return( amplitude );  
}

// Display the frequency domain.
// The spectrum is aranged so that DC is in the middle bin.
// Thus -Frequencies are on the left, +Frequencies on the right.
UpdateDisplay = function():Void
{
	var	n, aMagnitude, loop:Number;
	var aSample:Number;
	var lastPointX, lastPointY, currentPointX, currentPointY;
	var samplesUsed:Number;
	var maxPixels:Number = maxPixelsHorizontalAxis / 2;

	n = samples / 2;
	samplesUsed = n / zoomFactor;
    line_mc["i"+zoomFactor].clear();
    line_mc["i"+zoomFactor]._alpha = 100;
	
	UpdateMagnitude();
	for (loop = samples-samplesUsed; loop < samples; loop++)  
	{
		aMagnitude = AverageMagnitude(loop);
		aSample = loop - (samples - samplesUsed); 
        currentPointX = aSample * (maxPixels/samplesUsed) + xOffset;
        if (logAmplitude)
           currentPointY = yLogOffset - aMagnitude;
		else   
           currentPointY = yLinearOffset - aMagnitude;
		currentPointY = RangeCheckAmplitude( currentPointY );
        if (loop != (samples-samplesUsed))
           DrawLine(lastPointX, lastPointY, currentPointX, currentPointY);
		lastPointX = currentPointX;
		lastPointY = currentPointY;
	}

	for (loop = 1; loop < samplesUsed; loop++) 
	{
		aMagnitude = AverageMagnitude(loop);
        if (zoomFactor == 1)
           aSample = loop + n; 
        else
		   aSample = loop + n - samplesUsed; 
   		currentPointX = aSample * (maxPixels / samplesUsed) + xOffset;
        if (zoomFactor == 4)
		    currentPointX -= maxPixelsHorizontalAxis;
		else if (zoomFactor == 8)	
		    currentPointX -= (maxPixelsHorizontalAxis * 3);
        if (logAmplitude)
           currentPointY = yLogOffset - aMagnitude;
		else   
           currentPointY = yLinearOffset - aMagnitude;
		currentPointY = RangeCheckAmplitude( currentPointY );
        DrawLine(lastPointX, lastPointY, currentPointX, currentPointY);
		lastPointX = currentPointX;
		lastPointY = currentPointY;
	}
}

/*----------------------------------------------------------------
event handlers
----------------------------------------------------------------*/
ZoomIn_mc.onRollOver = ZoomOut_mc.onRollOver = function():Void
{
	this.gotoAndStop("over");
}

ZoomIn_mc.onRollOut = ZoomOut_mc.onRollOut = function():Void
{
	this.gotoAndStop("out");
}

ZoomIn_mc.onRelease = function():Void
{
//    logger.debug("line_mc alpha:", line_mc["i"+zoomFactor]._alpha);
	zoomTween = new Tween(line_mc["i"+zoomFactor], "_alpha", 
						  easing.Bounce.easeInOut, 80, 0, 1, true);
	zoomFactor *= 2;
    if (zoomFactor < 1 || zoomFactor > 8)
       zoomFactor = 1;
    ZoomEnableDisable( zoomFactor );
}

ZoomOut_mc.onRelease = function():Void
{
	zoomTween = new Tween(line_mc["i"+zoomFactor], "_alpha", 
						  easing.Bounce.easeInOut, 80, 0, 1, true);
	zoomFactor /= 2;
    if (zoomFactor < 1 || zoomFactor > 8)
       zoomFactor = 1;
    ZoomEnableDisable( zoomFactor );
}

ZoomEnableDisable = function(aZoom:Number):Void
{
	if ( aZoom <= 1)
	{  // disable ZoomOut button and enable ZoomIn button
//        logger.debug("ZoomOut disabled, ZoomIn enabled Callback", aZoom);
		ZoomOut_mc.gotoAndStop("disabled");
		ZoomIn_mc.gotoAndStop("out");
	    ZoomOut_mc.enabled = false;
		ZoomIn_mc.enabled = true;
	}
	else if ( aZoom >= 8)
	{  // enable ZoomOut button and disable ZoomIn button
//        logger.debug("ZoomOut enabled, ZoomIn disabled Callback", aZoom);
		ZoomOut_mc.gotoAndStop("out");
		ZoomIn_mc.gotoAndStop("disabled");
	    ZoomOut_mc.enabled = true;
		ZoomIn_mc.enabled = false;
	}
	else
	{  // enable ZoomOut button and enable ZoomIn button
//        logger.debug("ZoomOut enabled, ZoomIn enabled Callback", aZoom);
		ZoomOut_mc.gotoAndStop("out");
		ZoomIn_mc.gotoAndStop("out");
	    ZoomOut_mc.enabled = true;
		ZoomIn_mc.enabled = true;
	}
	UpdateDisplay();
}

/*----------------------------------------------------------------
run immediately
----------------------------------------------------------------*/
createEmptyMovieClip("line_mc", -1);
line_mc.createEmptyMovieClip("i1", 10);
line_mc.createEmptyMovieClip("i2", 11);
line_mc.createEmptyMovieClip("i4", 12);
line_mc.createEmptyMovieClip("i8", 13);

InitializeApplication();



