// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************
function client_SetForceIdrBackward1Alarm(anEvent)
{
   var aTarget = Get_Target( anEvent );
   if (aTarget)
   {
      if (IsChangeConfirmed("Force IDR Backward Alarm #1"))
      {
         if ( aTarget.value == "S" )
            serverAlarmBkIntf.SetForceIdrBackward1Alarm(STANDARD);
         else if ( aTarget.value == "Y" )
            serverAlarmBkIntf.SetForceIdrBackward1Alarm(FORCED_ON);
         else if ( aTarget.value == "N" )
            serverAlarmBkIntf.SetForceIdrBackward1Alarm(FORCED_OFF);
      }
   }
}

function client_SetForceIdrBackward2Alarm(anEvent)
{
   var aTarget = Get_Target( anEvent );
   if (aTarget)
   {
      if (IsChangeConfirmed("Force IDR Backward Alarm #2"))
      {
         if ( aTarget.value == "S" )
            serverAlarmBkIntf.SetForceIdrBackward2Alarm(STANDARD);
         else if ( aTarget.value == "Y" )
            serverAlarmBkIntf.SetForceIdrBackward2Alarm(FORCED_ON);
         else if ( aTarget.value == "N" )
            serverAlarmBkIntf.SetForceIdrBackward2Alarm(FORCED_OFF);
      }
   }
}

function client_SetForceIdrBackward3Alarm(anEvent)
{
   var aTarget = Get_Target( anEvent );
   if (aTarget)
   {
      if (IsChangeConfirmed("Force IDR Backward Alarm #3"))
      {
         if ( aTarget.value == "S" )
            serverAlarmBkIntf.SetForceIdrBackward3Alarm(STANDARD);
         else if ( aTarget.value == "Y" )
            serverAlarmBkIntf.SetForceIdrBackward3Alarm(FORCED_ON);
         else if ( aTarget.value == "N" )
            serverAlarmBkIntf.SetForceIdrBackward3Alarm(FORCED_OFF);
      }
   }
}

function client_SetForceIdrBackward4Alarm(anEvent)
{
   var aTarget = Get_Target( anEvent );
   if (aTarget)
   {
      if (IsChangeConfirmed("Force IDR Backward Alarm #4"))
      {
         if ( aTarget.value == "S" )
            serverAlarmBkIntf.SetForceIdrBackward4Alarm(STANDARD);
         else if ( aTarget.value == "Y" )
            serverAlarmBkIntf.SetForceIdrBackward4Alarm(FORCED_ON);
         else if ( aTarget.value == "N" )
            serverAlarmBkIntf.SetForceIdrBackward4Alarm(FORCED_OFF);
      }
   }
}

function client_SetForceIbsBackwardAlarm(anEvent)
{
   var aTarget = Get_Target( anEvent );
   if (aTarget)
   {
      if (IsChangeConfirmed("Force IBS Backward Alarm"))
      {
         if ( aTarget.value == "S" )
            serverAlarmBkIntf.SetForceIbsBackwardAlarm(STANDARD);
         else if ( aTarget.value == "Y" )
            serverAlarmBkIntf.SetForceIbsBackwardAlarm(FORCED_ON);
         else if ( aTarget.value == "N" )
            serverAlarmBkIntf.SetForceIbsBackwardAlarm(FORCED_OFF);
      }
   }
}

function client_SetForceT1E1BackwardAlarm(anEvent)
{
   var aTarget = Get_Target( anEvent );
   if (aTarget)
   {
      if (IsChangeConfirmed("Force T1E1 Backward Alarm"))
      {
         if ( aTarget.value == "S" )
            serverAlarmBkIntf.SetForceT1E1BackwardAlarm(STANDARD);
         else if ( aTarget.value == "Y" )
            serverAlarmBkIntf.SetForceT1E1BackwardAlarm(FORCED_ON);
         else if ( aTarget.value == "N" )
            serverAlarmBkIntf.SetForceT1E1BackwardAlarm(FORCED_OFF);
      }
   }
}

function client_SetForceIbsPromptAlarm(anEvent)
{
   var aTarget = Get_Target( anEvent );
   if (aTarget)
   {
      if (IsChangeConfirmed("Force IBS Prompt Alarm"))
      {
         if ( aTarget.value == "S" )
            serverAlarmBkIntf.SetForceIbsPromptAlarm(STANDARD);
         else if ( aTarget.value == "Y" )
            serverAlarmBkIntf.SetForceIbsPromptAlarm(FORCED_ON);
         else if ( aTarget.value == "N" )
            serverAlarmBkIntf.SetForceIbsPromptAlarm(FORCED_OFF);
      }
   }
}

function client_SetForceIbsServiceAlarm(anEvent)
{
   var aTarget = Get_Target( anEvent );
   if (aTarget)
   {
      if (IsChangeConfirmed("Force IBS Service Alarm"))
      {
         if ( aTarget.value == "S" )
            serverAlarmBkIntf.SetForceIbsServiceAlarm(STANDARD);
         else if ( aTarget.value == "Y" )
            serverAlarmBkIntf.SetForceIbsServiceAlarm(FORCED_ON);
         else if ( aTarget.value == "N" )
            serverAlarmBkIntf.SetForceIbsServiceAlarm(FORCED_OFF);
      }
   }
}

function client_SetMapSummaryAlarm()
{
   var anElement = Get_Iframe_Element( 'MapSummarySelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Map Summary Alarm To Backward"))
      {
         serverAlarmBkIntf.SetMapSummaryAlarm(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

function client_SetBackwardAlarmsStatusUpdate()
{
   serverAlarmBkIntf.SetBackwardAlarmsSelectContentUpdate();
   serverAlarmBkIntf.SetBackwardAlarmsStatusUpdate();
};

// ****************************************************************** 
// ****************************************************************** 
function Update_TransmittedIdrBackward1Alarm_Led(isLedOn)
{                                     
   Update_Alarm_Leds_Status(isLedOn, 'TransmittedIdrBackward1DarkLed', 'TransmittedIdrBackward1RedLed');
}

function Update_ReceivedIdrBackward1Alarm_Led(isLedOn)
{
   Update_Alarm_Leds_Status(isLedOn, 'ReceivedIdrBackward1DarkLed', 'ReceivedIdrBackward1RedLed');
}

function asyncUpdateAlarmsIdrBackward1Alarm( aTransmittedBackwardAlarm, aReceivedBackwardAlarm, aForceBackwardAlarm )
{
   var aForm = Get_Iframe_Element( 'alarmForm' ) ;
   if ( aForm )
   {
      if (aForm.ForceIdrBackward1Alarm)
      {
         if ( aForceBackwardAlarm == STANDARD )
   	      aForm.ForceIdrBackward1Alarm[STANDARD].checked = true;
         else if ( aForceBackwardAlarm == FORCED_ON )
   	      aForm.ForceIdrBackward1Alarm[FORCED_ON].checked = true;
         else if ( aForceBackwardAlarm == FORCED_OFF )
   	      aForm.ForceIdrBackward1Alarm[FORCED_OFF].checked = true;
      }
   }
   Update_TransmittedIdrBackward1Alarm_Led(aTransmittedBackwardAlarm);
   Update_ReceivedIdrBackward1Alarm_Led(aReceivedBackwardAlarm);
}

// ****************************************************************** 
function Update_TransmittedIdrBackward2Alarm_Led(isLedOn)
{                                     
   Update_Alarm_Leds_Status(isLedOn, 'TransmittedIdrBackward2DarkLed', 'TransmittedIdrBackward2RedLed');
}

function Update_ReceivedIdrBackward2Alarm_Led(isLedOn)
{
   Update_Alarm_Leds_Status(isLedOn, 'ReceivedIdrBackward2DarkLed', 'ReceivedIdrBackward2RedLed');
}

function asyncUpdateAlarmsIdrBackward2Alarm( aTransmittedBackwardAlarm, aReceivedBackwardAlarm, aForceBackwardAlarm )
{
   var aForm = Get_Iframe_Element( 'alarmForm' ) ;
   if ( aForm )
   {
      if (aForm.ForceIdrBackward2Alarm)
      {
         if ( aForceBackwardAlarm == STANDARD )
   	      aForm.ForceIdrBackward2Alarm[STANDARD].checked = true;
         else if ( aForceBackwardAlarm == FORCED_ON )
   	      aForm.ForceIdrBackward2Alarm[FORCED_ON].checked = true;
         else if ( aForceBackwardAlarm == FORCED_OFF )
   	      aForm.ForceIdrBackward2Alarm[FORCED_OFF].checked = true;
      }
   }
   Update_TransmittedIdrBackward2Alarm_Led(aTransmittedBackwardAlarm);
   Update_ReceivedIdrBackward2Alarm_Led(aReceivedBackwardAlarm);
}

// ****************************************************************** 
function Update_TransmittedIdrBackward3Alarm_Led(isLedOn)
{                                     
   Update_Alarm_Leds_Status(isLedOn, 'TransmittedIdrBackward3DarkLed', 'TransmittedIdrBackward3RedLed');
}

function Update_ReceivedIdrBackward3Alarm_Led(isLedOn)
{
   Update_Alarm_Leds_Status(isLedOn, 'ReceivedIdrBackward3DarkLed', 'ReceivedIdrBackward3RedLed');
}

function asyncUpdateAlarmsIdrBackward3Alarm( aTransmittedBackwardAlarm, aReceivedBackwardAlarm, aForceBackwardAlarm )
{
   var aForm = Get_Iframe_Element( 'alarmForm' ) ;
   if ( aForm )
   {
      if (aForm.ForceIdrBackward3Alarm)
      {
         if ( aForceBackwardAlarm == STANDARD )
   	      aForm.ForceIdrBackward3Alarm[STANDARD].checked = true;
         else if ( aForceBackwardAlarm == FORCED_ON )
   	      aForm.ForceIdrBackward3Alarm[FORCED_ON].checked = true;
         else if ( aForceBackwardAlarm == FORCED_OFF )
   	      aForm.ForceIdrBackward3Alarm[FORCED_OFF].checked = true;
      }
   }
   Update_TransmittedIdrBackward3Alarm_Led(aTransmittedBackwardAlarm);
   Update_ReceivedIdrBackward3Alarm_Led(aReceivedBackwardAlarm);
}

// ****************************************************************** 
function Update_TransmittedIdrBackward4Alarm_Led(isLedOn)
{                                     
   Update_Alarm_Leds_Status(isLedOn, 'TransmittedIdrBackward4DarkLed', 'TransmittedIdrBackward4RedLed');
}

function Update_ReceivedIdrBackward4Alarm_Led(isLedOn)
{
   Update_Alarm_Leds_Status(isLedOn, 'ReceivedIdrBackward4DarkLed', 'ReceivedIdrBackward4RedLed');
}

function asyncUpdateAlarmsIdrBackward4Alarm( aTransmittedBackwardAlarm, aReceivedBackwardAlarm, aForceBackwardAlarm )
{
   var aForm = Get_Iframe_Element( 'alarmForm' ) ;
   if ( aForm )
   {
      if (aForm.ForceIdrBackward4Alarm)
      {
         if ( aForceBackwardAlarm == STANDARD )
   	      aForm.ForceIdrBackward4Alarm[STANDARD].checked = true;
         else if ( aForceBackwardAlarm == FORCED_ON )
   	      aForm.ForceIdrBackward4Alarm[FORCED_ON].checked = true;
         else if ( aForceBackwardAlarm == FORCED_OFF )
   	      aForm.ForceIdrBackward4Alarm[FORCED_OFF].checked = true;
      }
   }
   Update_TransmittedIdrBackward4Alarm_Led(aTransmittedBackwardAlarm);
   Update_ReceivedIdrBackward4Alarm_Led(aReceivedBackwardAlarm);
}

// ****************************************************************** 
function Update_TransmittedIbsBackwardAlarm_Led(isLedOn)
{                                     
   Update_Alarm_Leds_Status(isLedOn, 'TransmittedIbsBackwardDarkLed', 'TransmittedIbsBackwardRedLed');
}

function Update_ReceivedIbsBackwardAlarm_Led(isLedOn)
{
   Update_Alarm_Leds_Status(isLedOn, 'ReceivedIbsBackwardDarkLed', 'ReceivedIbsBackwardRedLed');
}

function asyncUpdateAlarmsIbsBackwardAlarm( aTransmittedBackwardAlarm, aReceivedBackwardAlarm, aForceBackwardAlarm )
{
   var aForm = Get_Iframe_Element( 'alarmForm' ) ;
   if ( aForm )
   {
      if (aForm.ForceIbsBackwardAlarm)
      {
         if ( aForceBackwardAlarm == STANDARD )
   	      aForm.ForceIbsBackwardAlarm[STANDARD].checked = true;
         else if ( aForceBackwardAlarm == FORCED_ON )
   	      aForm.ForceIbsBackwardAlarm[FORCED_ON].checked = true;
         else if ( aForceBackwardAlarm == FORCED_OFF )
   	      aForm.ForceIbsBackwardAlarm[FORCED_OFF].checked = true;
      }
   }
   Update_TransmittedIbsBackwardAlarm_Led(aTransmittedBackwardAlarm);
   Update_ReceivedIbsBackwardAlarm_Led(aReceivedBackwardAlarm);
}

// ****************************************************************** 
function Update_TransmittedT1E1BackwardAlarm_Led(isLedOn)
{                                     
   Update_Alarm_Leds_Status(isLedOn, 'TransmittedT1E1BackwardDarkLed', 'TransmittedT1E1BackwardRedLed');
}

function Update_ReceivedT1E1BackwardAlarm_Led(isLedOn)
{
   Update_Alarm_Leds_Status(isLedOn, 'ReceivedT1E1BackwardDarkLed', 'ReceivedT1E1BackwardRedLed');
}

function asyncUpdateAlarmsT1E1BackwardAlarm( aTransmittedBackwardAlarm, aReceivedBackwardAlarm, aForceBackwardAlarm )
{
   var aForm = Get_Iframe_Element( 'alarmForm' ) ;
   if ( aForm )
   {
      if (aForm.ForceT1E1BackwardAlarm)
      {
         if ( aForceBackwardAlarm == STANDARD )
   	      aForm.ForceT1E1BackwardAlarm[STANDARD].checked = true;
         else if ( aForceBackwardAlarm == FORCED_ON )
   	      aForm.ForceT1E1BackwardAlarm[FORCED_ON].checked = true;
      }
   }
   Update_TransmittedT1E1BackwardAlarm_Led(aTransmittedBackwardAlarm);
   Update_ReceivedT1E1BackwardAlarm_Led(aReceivedBackwardAlarm);
}

// ****************************************************************** 
function Update_CurrentIbsPromptAlarm_Led(isLedOn)
{                                     
   Update_Alarm_Leds_Status(isLedOn, 'CurrentIbsPromptDarkLed', 'CurrentIbsPromptRedLed');
}

function asyncUpdateAlarmsIbsPromptAlarm( aCurrentPromptAlarm, aForcePromptAlarm )
{
   var aForm = Get_Iframe_Element( 'alarmForm' ) ;
   if ( aForm )
   {
      if (aForm.ForceIbsPromptAlarm)
      {
         if ( aForcePromptAlarm == STANDARD )
   	      aForm.ForceIbsPromptAlarm[STANDARD].checked = true;
         else if ( aForcePromptAlarm == FORCED_ON )
   	      aForm.ForceIbsPromptAlarm[FORCED_ON].checked = true;
      }
   }
   Update_CurrentIbsPromptAlarm_Led(aCurrentPromptAlarm);
}

// ****************************************************************** 
function Update_CurrentIbsServiceAlarm_Led(isLedOn)
{                                     
   Update_Alarm_Leds_Status(isLedOn, 'CurrentIbsServiceDarkLed', 'CurrentIbsServiceRedLed');
}

function asyncUpdateAlarmsIbsServiceAlarm( aCurrentServiceAlarm, aForceServiceAlarm )
{
   var aForm = Get_Iframe_Element( 'alarmForm' ) ;
   if ( aForm )
   {
      if (aForm.ForceIbsServiceAlarm)
      {
         if ( aForceServiceAlarm == STANDARD )
   	      aForm.ForceIbsServiceAlarm[STANDARD].checked = true;
         else if ( aForceServiceAlarm == FORCED_ON )
   	      aForm.ForceIbsServiceAlarm[FORCED_ON].checked = true;
      }
   }
   Update_CurrentIbsServiceAlarm_Led(aCurrentServiceAlarm);
}

// ****************************************************************** 

function asyncUpdateAlarmsMapSummaryStatus(aMapSummary)
{
   var anElement = Get_Iframe_Element( 'MapSummarySelect' ) ;
   if ( anElement )	                    // Set map summary alarm
      anElement.value = aMapSummary;
}

function asyncUpdateAlarmsMapSummarySelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'MapSummarySelect', aSelectContent );
}

