var iFrameLink;
var gnavNameSelected;

var LED_OFF = 0;
var LED_ON = 1;

var MASK = 0;
var UNMASK = 1;

var NO = 0;
var YES = 1;

var isDebugMode = 0;

var STANDARD = 0;
var FORCED_ON = 1;
var FORCED_OFF = 2;

var isDebugMode = 0;
var MAX_CHANNELS = 30;
var MAX_TIMESLOTS = 31;

// Installed options
var bFeatureOptionCnc52MbpsInstalled = 0;
var bFeatureOptionCnc40MbpsInstalled = 0;
var bFeatureOptionCnc30MbpsInstalled = 0;
var bFeatureOptionCnc25MbpsInstalled = 0;
var bFeatureOptionCnc20MbpsInstalled = 0;
var bFeatureOptionCnc15MbpsInstalled = 0;
var bFeatureOptionCnc10MbpsInstalled = 0;
var bFeatureOptionCnc5MbpsInstalled = 0;
var bFeatureOptionCnc1MbpsInstalled = 0;
var bFeatureOptionCnc512KbpsInstalled = 0;
var bFeatureOptionLdpc20MhzInstalled = 0;
var bFeatureOptionLdpc10MhzInstalled = 0;
var bFeatureOptionLdpc5MhzInstalled = 0;
var bFeatureOption8QamInstalled = 0;
var bFeatureOptionEthWanMonitorInstalled = 0;
var bFeatureOptionR11ScramblerInstalled = 0;
var bFeatureOptionTpc78sInstalled = 0;
var bFeatureFskInstalled = 0;
var bFeatureOptionTpc52MhzInstalled = 0;
var bFeatureDr52MbpsInstalled = 0;
var bFeatureDr512KbpsInstalled = 0;
var bFeatureOptionEdMacInstalled = 0;
var bFeatureOptionDvbInstalled = 0;
var bFeatureOptionOm73Installed = 0;
var bFeatureOptionTpc20MhzInstalled = 0;
var bFeatureOptionTpc5MhzInstalled = 0;
var bFeatureOption16QamInstalled = 0;
var bFeatureOption8PskInstalled = 0;
var bFeatureOptionAupcInstalled = 0;
var bFeatureOptionDnIInstalled = 0;
var bFeatureOptionIbsInstalled = 0;
var bFeatureOptionRsCustomInstalled = 0;
var bFeatureOptionRsInstalled = 0;
var bFeatureOptionSeqInstalled = 0;
var bFeatureOptionIdrInstalled = 0;
var bFeatureOptionEnhancedAsyncInstalled = 0;
var bFeatureBandTxLBandInstalled = 0;
var bFeatureBandTxIfInstalled = 0;
var bFeatureBandRxLBandInstalled = 0;
var bFeatureBandRxIfInstalled = 0;
var bFeatureDr20MbpsInstalled = 0;
var bFeatureDr10MbpsInstalled = 0;
var bFeatureDr5MbpsInstalled = 0;
var bFeatureDr1MbpsInstalled = 0;

var bIsFskTestResultNeeded = 0;
var bIsRxTestPatternEnabled = 0;
var bIsTxIbsOrSccEnabled = 0;
var bIsRxIbsOrSccEnabled = 0;
var bIsTxEfficientDnIAsyncEnabled = 0;
var bIsRxEfficientDnIAsyncEnabled = 0;
var bIsTxSccEnabled = 0;
var bIsRxSccEnabled = 0;
var bIsEthernetEnabled = 0;
var bIsTxDropEnabled = 0;
var bIsRxInsertEnabled = 0;
var bIsTxVoiceEscOverheadEnabled = 0;
var bIsRxVoiceEscOverheadEnabled = 0;
var bIsEfaupcPossible = 0;
var bIsAupcEnabled = 0;
var bIsRadyneAupcPossible = 0;
var bIsTxEscEnabled = 0;
var bIsRxEscEnabled = 0;
var bIsTxBpskEnabled = 0;
var bIsRxBpskEnabled = 0;
var bIsTxSatFramingIbs = 0;
var bIsRxSatFramingIbs = 0;
var bIsTxEscEnhancedEnabled = 0;
var bIsRxEscEnhancedEnabled = 0;

var bUseTxDiffCodingMenu = 0;
var bUseRxDiffCodingMenu = 0;
var bUseVersionMenu = 0;
var bUseUserNameMenus = 0;
var bUseTxTpcMenus = 0;
var bUseNonRxTpcAnd16QamMenus = 0;
var bUseRxTpcMenus = 0;
var bUseSysRefHighStabilityMenus = 0;
var bUseSysRefInternalMenus = 0;
var bUseSecurityProtocolMenus = 0;
var bUseRxBufferMenus = 0;
var bUsePasswordMenus = 0;
var bUseNonTxTpcMenus = 0;
var bUseNonRxTpcMenus = 0;
var bUseNonLbstTxMenus = 0;
var bUseLbstTxMenus = 0;
var bUseNonLbstRxMenus = 0;
var bUseLbstRxMenus = 0;
var bUseNonFskMenus = 0;
var bUseFskMenus = 0;
var bUseCommunityMenus = 0;
var bUseBasebandBer = 0;
var bUseUncoded8PskRxMenus = 0;
var bAllowRelayUsageMenus = 0;

var terrInterfaceBoardType = 0;
var modemType = 0;
var userConfirmation = 0;
var featureDemoCount = 0;
var deleteAllEventsCount = 0;

var Modem_DMD20_TYPE = 1;
var Modem_DMD20LBST_TYPE = 2;
var Modem_DMD2050_TYPE = 3;
var Modem_IMT_TYPE = 4;
var Modem_DMD50_TYPE = 5;
var Modem_DMD1050_TYPE = 6;
          
function Initialize_Monitor_Site()
{
   // Initialize the event handler
   Initialize_Site();

   // Preload images into the browser for fast updates
   preloadImages();

   // Hide unused Led images
   Hide_Led_Images();

   // Load iFrame
   gnavNameSelected = 'gnavTransmit';
   buildButtons();

   UpdateIframe("xmitif.htm", "inlineFrameId", gnavNameSelected);
};

function Get_Target( anEvent )
{
   anEvent = (anEvent) ? anEvent : ((window.event) ? event : null);
   var target = (anEvent.target) ? anEvent.target : anEvent.srcElement;
   return target;
}

function Hide_Element(elementId)
{
   var anElement;

   anElement = document.getElementById(elementId);
   if ( anElement )
      anElement.style.visibility='hidden';
}

function Show_Element(elementId)
{
   var anElement;

   anElement = document.getElementById(elementId);
   if ( anElement )
      anElement.style.visibility='visible';
}

function Update_Element_Select_Content( anElement, aSelectContent)
{
   if ( anElement )
   {
      var dbContent = aSelectContent.split("\n");
      anElement.options.length = 0;
      if ( dbContent.length )
      {
         var isSelected;
         for (var i = 0; i < dbContent.length -1; i++)
         {
            isSelected = parseInt(dbContent[i].split(",")[2]);
            anElement.options[i] = new Option(dbContent[i].split(",")[0],
                                           dbContent[i].split(",")[1],
                                           false,
                                           isSelected);
         }
      }
   }
}

function Update_Transmit_On_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('modTransmitOnDarkLed');
      Show_Element('modTransmitOnGreenLed');
   }
   else
   {
      Show_Element('modTransmitOnDarkLed');
      Hide_Element('modTransmitOnGreenLed');
   }
}

function Update_Transmit_Major_Alarm_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('modMajorAlarmDarkLed');
      Show_Element('modMajorAlarmRedLed');
   }
   else
   {
      Show_Element('modMajorAlarmDarkLed');
      Hide_Element('modMajorAlarmRedLed');
   }
}

function Update_Transmit_Minor_Alarm_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('modMinorAlarmDarkLed');
      Show_Element('modMinorAlarmYellowLed');
   }
   else
   {
      Show_Element('modMinorAlarmDarkLed');
      Hide_Element('modMinorAlarmYellowLed');
   }
}

function Update_Transmit_Test_Mode_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('modTestModeDarkLed');
      Show_Element('modTestModeYellowLed');
   }
   else
   {
      Show_Element('modTestModeDarkLed');
      Hide_Element('modTestModeYellowLed');
   }
}

function Update_Receive_Signal_Lock_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('signalLockDarkLed');
      Show_Element('signalLockGreenLed');
   }
   else
   {
      Show_Element('signalLockDarkLed');
      Hide_Element('signalLockGreenLed');
   }
}

function Update_Receive_Major_Alarm_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('demodMajorAlarmDarkLed');
      Show_Element('demodMajorAlarmRedLed');
   }
   else
   {
      Show_Element('demodMajorAlarmDarkLed');
      Hide_Element('demodMajorAlarmRedLed');
   }
}

function Update_Receive_Minor_Alarm_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('demodMinorAlarmDarkLed');
      Show_Element('demodMinorAlarmYellowLed');
   }
   else
   {
      Show_Element('demodMinorAlarmDarkLed');
      Hide_Element('demodMinorAlarmYellowLed');
   }
}

function Update_Receive_Test_Mode_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('demodTestModeDarkLed');
      Show_Element('demodTestModeYellowLed');
   }
   else
   {
      Show_Element('demodTestModeDarkLed');
      Hide_Element('demodTestModeYellowLed');
   }
}

function Update_Common_Power_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('powerDarkLed');
      Show_Element('powerGreenLed');
   }
   else
   {
      Show_Element('powerDarkLed');
      Hide_Element('powerGreenLed');
   }
}

function Update_Common_Fault_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('faultDarkLed');
      Show_Element('faultRedLed');
   }
   else
   {
      Show_Element('faultDarkLed');
      Hide_Element('faultRedLed');
   }
}

function Update_Common_Event_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('eventDarkLed');
      Show_Element('eventYellowLed');
   }
   else
   {
      Show_Element('eventDarkLed');
      Hide_Element('eventYellowLed');
   }
}

function Update_Common_Remote_Led(isLedOn)
{
   if (isLedOn)
   {
      Hide_Element('remoteDarkLed');
      Show_Element('remoteGreenLed');
   }
   else
   {
      Show_Element('remoteDarkLed');
      Hide_Element('remoteGreenLed');
   }
}

function Hide_Led_Images()
{
   Update_Transmit_On_Led(LED_OFF);
   Update_Transmit_Major_Alarm_Led(LED_OFF);
   Update_Transmit_Minor_Alarm_Led(LED_OFF);
   Update_Transmit_Test_Mode_Led(LED_OFF);

   Update_Receive_Signal_Lock_Led(LED_OFF);
   Update_Receive_Major_Alarm_Led(LED_OFF);
   Update_Receive_Minor_Alarm_Led(LED_OFF);
   Update_Receive_Test_Mode_Led(LED_OFF);

   Update_Common_Power_Led(LED_OFF);
   Update_Common_Fault_Led(LED_OFF);
   Update_Common_Event_Led(LED_OFF);
   Update_Common_Remote_Led(LED_OFF);
}

// ******************************************************************
//       * Functions triggered by events in client user interface
// ******************************************************************

// ******************************************************************
// * Functions called asynchronously from the server.
// ******************************************************************
function asyncUpdateMonitorTxLedStatus(aTransmitOnLed, aTxMajorAlarmLed, aTxMinorAlarmLed, aTxTestModeLed)
{
   Update_Transmit_On_Led(aTransmitOnLed);                // Update transmit On Led
   Update_Transmit_Major_Alarm_Led(aTxMajorAlarmLed);     // Update transmit major alarm Led
   Update_Transmit_Minor_Alarm_Led(aTxMinorAlarmLed);     // Update transmit minor alarm Led
   Update_Transmit_Test_Mode_Led(aTxTestModeLed);         // Update transmit test mode Led
}

function asyncUpdateMonitorRxLedStatus(aPllLockLed, aRxMajorAlarmLed, aRxMinorAlarmLed, aRxTestModeLed)
{
   Update_Receive_Signal_Lock_Led(aPllLockLed);              // Update receive PLL lock Led
   Update_Receive_Major_Alarm_Led(aRxMajorAlarmLed);      // Update receive major alarm Led
   Update_Receive_Minor_Alarm_Led(aRxMinorAlarmLed);      // Update receive minor alarm Led
   Update_Receive_Test_Mode_Led(aRxTestModeLed);          // Update receive test mode Led
}

function asyncUpdateMonitorSysLedStatus(aPowerLed, aFaultLed, anEventLed, aRemoteLed)
{
   Update_Common_Power_Led(aPowerLed);                    // Update the Power Led
   Update_Common_Fault_Led(aFaultLed);                    // Update the Fault Led
   Update_Common_Event_Led(anEventLed);                   // Update the Event Led
   Update_Common_Remote_Led(aRemoteLed);                  // Update the Remote Led
}

function asyncUpdateMonitorSetErrorStatus(sysSetError)
{
   if ( sysSetError )
   {  // Error during SET operation
      alert( "ERROR PROCESSING COMMAND!!!" );
      RefreshIframe();          // Reload current iFrame
   }
}

function asyncUpdateMonitorInstalledFeaturesStatus( installedFeatures )
{
   bFeatureOptionEthWanMonitorInstalled   = (installedFeatures & 0x40000000) ? true : false;
   bFeatureOptionR11ScramblerInstalled    = (installedFeatures & 0x20000000) ? true : false;
   bFeatureOptionTpc78sInstalled          = (installedFeatures & 0x10000000) ? true : false;
   bFeatureFskInstalled                   = (installedFeatures & 0x04000000) ? true : false;
   bFeatureOptionTpc52MhzInstalled        = (installedFeatures & 0x02000000) ? true : false;
   bFeatureDr52MbpsInstalled              = (installedFeatures & 0x01000000) ? true : false;

   bFeatureDr512KbpsInstalled             = (installedFeatures & 0x800000) ? true : false;
   bFeatureOptionEdMacInstalled           = (installedFeatures & 0x400000) ? true : false;
   bFeatureOptionDvbInstalled             = (installedFeatures & 0x200000) ? true : false;
   bFeatureOptionOm73Installed            = (installedFeatures & 0x100000) ? true : false;
   bFeatureOptionTpc20MhzInstalled        = (installedFeatures & 0x080000) ? true : false;
   bFeatureOptionTpc5MhzInstalled         = (installedFeatures & 0x040000) ? true : false;
   bFeatureOption16QamInstalled           = (installedFeatures & 0x020000) ? true : false;
   bFeatureOption8PskInstalled            = (installedFeatures & 0x010000) ? true : false;

   bFeatureOptionAupcInstalled            = (installedFeatures & 0x008000) ? true : false;
   bFeatureOptionDnIInstalled             = (installedFeatures & 0x004000) ? true : false;
   bFeatureOptionIbsInstalled             = (installedFeatures & 0x002000) ? true : false;
   bFeatureOptionRsCustomInstalled        = (installedFeatures & 0x001000) ? true : false;
   bFeatureOptionRsInstalled              = (installedFeatures & 0x000800) ? true : false;
   bFeatureOptionSeqInstalled             = (installedFeatures & 0x000400) ? true : false;
   bFeatureOptionIdrInstalled             = (installedFeatures & 0x000200) ? true : false;
   bFeatureOptionEnhancedAsyncInstalled   = (installedFeatures & 0x000100) ? true : false;

   bFeatureBandTxLBandInstalled           = (installedFeatures & 0x000080) ? true : false;
   bFeatureBandTxIfInstalled              = (installedFeatures & 0x000040) ? true : false;
   bFeatureBandRxLBandInstalled           = (installedFeatures & 0x000020) ? true : false;
   bFeatureBandRxIfInstalled              = (installedFeatures & 0x000010) ? true : false;
   bFeatureDr20MbpsInstalled              = (installedFeatures & 0x000008) ? true : false;
   bFeatureDr10MbpsInstalled              = (installedFeatures & 0x000004) ? true : false;
   bFeatureDr5MbpsInstalled               = (installedFeatures & 0x000002) ? true : false;
   bFeatureDr1MbpsInstalled               = (installedFeatures & 0x000001) ? true : false;
}

function asyncUpdateMonitorInstalledFeatures2Status( installedFeatures )
{
   bFeatureOptionCnc52MbpsInstalled       = (installedFeatures & 0x00002000) ? true : false;
   bFeatureOptionCnc40MbpsInstalled       = (installedFeatures & 0x00001000) ? true : false;
   bFeatureOptionCnc30MbpsInstalled       = (installedFeatures & 0x00000800) ? true : false;
   bFeatureOptionCnc25MbpsInstalled       = (installedFeatures & 0x00000400) ? true : false;
   bFeatureOptionCnc20MbpsInstalled       = (installedFeatures & 0x00000200) ? true : false;
   bFeatureOptionCnc15MbpsInstalled       = (installedFeatures & 0x00000100) ? true : false;

   bFeatureOptionCnc10MbpsInstalled       = (installedFeatures & 0x00000080) ? true : false;
   bFeatureOptionCnc5MbpsInstalled        = (installedFeatures & 0x00000040) ? true : false;
   bFeatureOptionCnc1MbpsInstalled        = (installedFeatures & 0x00000020) ? true : false;
   bFeatureOptionCnc512KbpsInstalled      = (installedFeatures & 0x00000010) ? true : false;
   bFeatureOptionLdpc20MhzInstalled       = (installedFeatures & 0x00000008) ? true : false;
   bFeatureOptionLdpc10MhzInstalled       = (installedFeatures & 0x00000004) ? true : false;
   bFeatureOptionLdpc5MhzInstalled        = (installedFeatures & 0x00000002) ? true : false;
   bFeatureOption8QamInstalled            = (installedFeatures & 0x00000001) ? true : false;
}

function asyncUpdateMonitorUiGeneratorsEnabledStatus( installedFeatures )
{
   bIsFskTestResultNeeded                 = (installedFeatures & 0x800000) ? true : false;
   bIsRxTestPatternEnabled                = (installedFeatures & 0x400000) ? true : false;
   bIsTxIbsOrSccEnabled                   = (installedFeatures & 0x200000) ? true : false;
   bIsRxIbsOrSccEnabled                   = (installedFeatures & 0x100000) ? true : false;
   bIsTxEfficientDnIAsyncEnabled          = (installedFeatures & 0x080000) ? true : false;
   bIsRxEfficientDnIAsyncEnabled          = (installedFeatures & 0x040000) ? true : false;
   bIsTxSccEnabled                        = (installedFeatures & 0x020000) ? true : false;
   bIsRxSccEnabled                        = (installedFeatures & 0x010000) ? true : false;

   bIsEthernetEnabled                     = (installedFeatures & 0x008000) ? true : false;
   bIsTxDropEnabled                       = (installedFeatures & 0x004000) ? true : false;
   bIsRxInsertEnabled                     = (installedFeatures & 0x002000) ? true : false;
   bIsTxVoiceEscOverheadEnabled           = (installedFeatures & 0x001000) ? true : false;
   bIsRxVoiceEscOverheadEnabled           = (installedFeatures & 0x000800) ? true : false;
   bIsEfaupcPossible                      = (installedFeatures & 0x000400) ? true : false;
   bIsAupcEnabled                         = (installedFeatures & 0x000200) ? true : false;
   bIsRadyneAupcPossible                  = (installedFeatures & 0x000100) ? true : false;

   bIsTxEscEnabled                        = (installedFeatures & 0x000080) ? true : false;
   bIsRxEscEnabled                        = (installedFeatures & 0x000040) ? true : false;
   bIsTxBpskEnabled                       = (installedFeatures & 0x000020) ? true : false;
   bIsRxBpskEnabled                       = (installedFeatures & 0x000010) ? true : false;
   bIsTxSatFramingIbs                     = (installedFeatures & 0x000008) ? true : false;
   bIsRxSatFramingIbs                     = (installedFeatures & 0x000004) ? true : false;
   bIsTxEscEnhancedEnabled                = (installedFeatures & 0x000002) ? true : false;
   bIsRxEscEnhancedEnabled                = (installedFeatures & 0x000001) ? true : false;
}

function asyncUpdateMonitorUiGeneratorsUseMenusStatus( installedFeatures )
{
   bAllowRelayUsageMenus                  = (installedFeatures & 0x800000) ? true : false;
   bUseUncoded8PskRxMenus                 = (installedFeatures & 0x400000) ? true : false;
   bUseTxDiffCodingMenu                   = (installedFeatures & 0x200000) ? true : false;
   bUseRxDiffCodingMenu                   = (installedFeatures & 0x100000) ? true : false;
   bUseVersionMenu                        = (installedFeatures & 0x080000) ? true : false;
   bUseUserNameMenus                      = (installedFeatures & 0x040000) ? true : false;
   bUseTxTpcMenus                         = (installedFeatures & 0x020000) ? true : false;
   bUseNonRxTpcAnd16QamMenus              = (installedFeatures & 0x010000) ? true : false;

   bUseRxTpcMenus                         = (installedFeatures & 0x008000) ? true : false;
   bUseSysRefHighStabilityMenus           = (installedFeatures & 0x004000) ? true : false;
   bUseSysRefInternalMenus                = (installedFeatures & 0x002000) ? true : false;
   bUseSecurityProtocolMenus              = (installedFeatures & 0x001000) ? true : false;
   bUseRxBufferMenus                      = (installedFeatures & 0x000800) ? true : false;
   bUsePasswordMenus                      = (installedFeatures & 0x000400) ? true : false;
   bUseNonTxTpcMenus                      = (installedFeatures & 0x000200) ? true : false;
   bUseNonRxTpcMenus                      = (installedFeatures & 0x000100) ? true : false;

   bUseNonLbstTxMenus                     = (installedFeatures & 0x000080) ? true : false;
   bUseLbstTxMenus                        = (installedFeatures & 0x000040) ? true : false;
   bUseNonLbstRxMenus                     = (installedFeatures & 0x000020) ? true : false;
   bUseLbstRxMenus                        = (installedFeatures & 0x000010) ? true : false;
   bUseNonFskMenus                        = (installedFeatures & 0x000008) ? true : false;
   bUseFskMenus                           = (installedFeatures & 0x000004) ? true : false;
   bUseCommunityMenus                     = (installedFeatures & 0x000002) ? true : false;
   bUseBasebandBer                        = (installedFeatures & 0x000001) ? true : false;
}

function asyncUpdateMonitorTerrInterfaceStatus( aTerrInterface)
{
   terrInterfaceBoardType = aTerrInterface;
}

function asyncUpdateMonitorModemTypeStatus(aModemType)
{
   modemType = aModemType;
   evIsConnected = true;               // Flag persistent connection is established
}

function asyncUpdateMonitorUserConfirmationStatus(aUserConfirmation)
{
   userConfirmation = aUserConfirmation;
}

function asyncUpdateSetPreferencesUserConfirmationStatus(aUserConfirmation)
{
   userConfirmation = aUserConfirmation;
}

function asyncUpdateMonitorFeatureDemoCountStatus(aFeatureDemoCount)
{
   featureDemoCount = aFeatureDemoCount;
}

function asyncUpdateMonitorEventBufferDeleteAllCountStatus(aDeleteAllEventsCount)
{
   deleteAllEventsCount = aDeleteAllEventsCount;
}

function RefreshIframe()
{
   if ( iFrameLink )
      UpdateIframe(iFrameLink, "inlineFrameId", gnavNameSelected);
}

function OpenPdfWindow(aPdfFile)
{
   var aPdfWindow = window.open(aPdfFile, "pdfWindow",
        "scrollbars=yes,resizable=yes,location=no,width=750,height=650");
   aPdfWindow.focus();
}

function OpenContactWindow(aLink)
{
   var aContactWindow = window.open(aLink, "contactWindow",
        "toolbar=yes,scrollbars=yes,resizable=yes,width=750,height=650");
   aContactWindow.focus();
}

function OpenGraphWindow(aLink, navName)
{
   var aGraphWindow = window.open(aLink, "graphWindow",
        "toolbar=no,scrollbars=no,resizable=no,width=550,height=400");
   aGraphWindow.focus();
}