// ****************************************************************** 
function client_SetRxCncMode()
{
   var anElement = Get_Iframe_Element( 'RxCncModeSelect' ) ;
   if ( anElement )
   {
      if (IsChangeConfirmed("Rx CnC Mode"))
      {
         serverRcvCncIntf.SetRxCncMode(parseInt(anElement.value, 10));
         Focus_Iframe();
      }
   }
};

function client_SetRxCncMinSearchDelay(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'RxCncMinSearchDelayInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Rx Min Search Delay"))
            {
               serverRcvCncIntf.SetRxCncMinSearchDelay(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetRxCncMaxSearchDelay(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'RxCncMaxSearchDelayInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Rx Max Search Delay"))
            {
               serverRcvCncIntf.SetRxCncMaxSearchDelay(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetRxCncFreqOffsetRange(anEvent)
{
   anEvent = (anEvent) ? anEvent : event;
   var charCode = (anEvent.charCode) ? anEvent.charCode : 
                  ((anEvent.which) ? anEvent.which : anEvent.keyCode);
   if (charCode == 13 || charCode == 3)
   {
      var anElement = Get_Iframe_Element( 'RxCncFreqOffsetRangeInput' ) ;
      if ( anElement )
      {
         if (IsNumber(anElement))
         {
            if (IsChangeConfirmed("Rx Frequency Offset"))
            {
               serverRcvCncIntf.SetRxCncFreqOffsetRange(parseInt(anElement.value, 10));
               Focus_Iframe();
            }
         }
      }
   }
};

function client_SetRxCncStatusUpdate()
{
   serverRcvCncIntf.SetRxCncSelectContentUpdate();
   serverRcvCncIntf.SetRxCncStatusUpdate();
};

// ****************************************************************** 
function asyncUpdateRcvCncModeStatus(aCncMode)
{
   var anElement = Get_Iframe_Element( 'RxCncModeSelect' ) ;
   if ( anElement )	      // Set receive CnC mode
      anElement.value = aCncMode;
}

function asyncUpdateRcvCncMinSearchDelayStatus(aMinSearchDelay)
{
   var anElement = Get_Iframe_Element( 'RxCncMinSearchDelayInput' ) ;
   if ( anElement )	       // Set receive minimum search delay
      anElement.value = aMinSearchDelay;
}

function asyncUpdateRcvCncMaxSearchDelayStatus(aMaxSearchDelay)
{
   var anElement = Get_Iframe_Element( 'RxCncMaxSearchDelayInput' ) ;
   if ( anElement )	       // Set receive maximum search delay
      anElement.value = aMaxSearchDelay;
}

function asyncUpdateRcvCncFreqOffsetRangeStatus(aFreqOffset)
{
   var anElement = Get_Iframe_Element( 'RxCncFreqOffsetRangeInput' ) ;
   if ( anElement )	       // Set receive frequency offset range
      anElement.value = aFreqOffset;
}

// ****************************************************************** 
function asyncUpdateRcvCncModeSelectContent(aSelectContent)
{
   Update_Iframe_Element_Select_Content( 'RxCncModeSelect', aSelectContent );
}
