// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

// ************************************************************************************
function client_SetFeatureId(anEvent)
{
   var aElement = Get_Iframe_Element( 'FeatureIdAInput' ) ;
   var bElement = Get_Iframe_Element( 'FeatureIdBInput' ) ;
   var cElement = Get_Iframe_Element( 'FeatureIdCInput' ) ;
   if ( aElement && bElement && cElement )
   {
      if (IsNumber(aElement) && IsNumber(bElement) && IsNumber(cElement) )
      {
         if (IsChangeConfirmed("Feature ID"))
         {
            serverSysFeatrIntf.SetFeatureId(parseInt(aElement.value, 10), 
                                            parseInt(bElement.value, 10),
                                            parseInt(cElement.value, 10));
            Focus_Iframe();
         }
      }
   }                           
   setTimeout("RefreshIframe();", 250);
};

// ************************************************************************************
function client_CancelDemoFeatureId(anEvent)
{
   if (IsChangeConfirmed("Cancel Demo Features"))
   {
      featureDemoCount = featureDemoCount + 1;
      serverSysFeatrIntf.CancelDemoFeatureId(featureDemoCount);
      Focus_Iframe();
   }                           
   setTimeout("RefreshIframe();", 250);
   
};

// ************************************************************************************
// Name   : client_SetSysFeatrStatusUpdate()
// Purpose: Called when the current iFrame loads
// Inputs : NONE
// Outputs: NONE
function client_SetSysFeatrStatusUpdate()
{
   serverSysFeatrIntf.SetSysFeatrStatusUpdate();
};

// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************
function asyncUpdateSysFeatrIdStatus(featureA, featureB, featureC)
{
   var anElement = Get_Iframe_Element( 'FeatureIdAInput' ) ;
   if ( anElement )
      anElement.value = featureA;

   anElement = Get_Iframe_Element( 'FeatureIdBInput' ) ;
   if ( anElement )
      anElement.value = featureB;

   anElement = Get_Iframe_Element( 'FeatureIdCInput' ) ;
   if ( anElement )
      anElement.value = featureC;
}

function asyncUpdateSysFeatrIdModeStatus(aFeatrIdMode)
{
   var anElement = Get_Iframe_Element( 'FeatureModeInput' ) ;
   if ( anElement )
      anElement.value = aFeatrIdMode;
}
