// ****************************************************************** 
//       * Functions triggered by events in client user interface
// ******************************************************************

// ************************************************************************************
// Purpose: Called when the current iFrame loads
function client_SetSysConfStatusUpdate()
{
   serverSysConfIntf.SetSysConfStatusUpdate();
};


// ****************************************************************** 
// * Functions called asynchronously from the server.
// ******************************************************************
function asyncUpdateSysFirmwareAndLabelStatus(aFirmwareAndLabel)
{
   var anElement = Get_Iframe_Element( 'FirmwareAndLabelInput' ) ;
   if( anElement )
      anElement.value = aFirmwareAndLabel;
}

function asyncUpdateSysMcStampStatus(aMcStamp)
{
   var anElement = Get_Iframe_Element( 'McStampInput' ) ;
   if( anElement )
      anElement.value = aMcStamp;
}

function asyncUpdateSysMcBoardStatus(aMcBoard)
{
   var anElement = Get_Iframe_Element( 'McBoardInput' ) ;
   if( anElement )
      anElement.value = aMcBoard;
}

function asyncUpdateSysIfBoardStatus(anIfBoard)
{
   var anElement = Get_Iframe_Element( 'IfBoardInput' ) ;
   if( anElement )
      anElement.value = anIfBoard;
}

function asyncUpdateSysTerrBoardStatus(aTerrBoard)
{
   var anElement = Get_Iframe_Element( 'TerrBoardInput' ) ;
   if( anElement )
      anElement.value = aTerrBoard;
}

function asyncUpdateSysCodecBoardStatus( aCodecBoard )
{
   var anElement = Get_Iframe_Element( 'CodecBoardInput' );
   if( anElement )
      anElement.value = aCodecBoard;
}

function asyncUpdateSysFpBoardStatus( aFpBoard )
{
   var anElement = Get_Iframe_Element( 'FpBoardInput' );
   if( anElement )
      anElement.value = aFpBoard;
}

function asyncUpdateSysBucIdStatus( aSysBucId )
{
   if( aSysBucId )
   {
      var anElement = Get_Iframe_Element( 'BucIdInput' );
      if( anElement )
         anElement.value = aSysBucId;
   }
}

function asyncUpdateSysBucSerialNumberStatus( aSysBucSerialNumber )
{
   if( aSysBucSerialNumber )
   {
      var anElement = Get_Iframe_Element( 'BucSerialNumberInput' );
      if( anElement )
         anElement.value = aSysBucSerialNumber;
   }
}
